import json
import requests
import pandas as pd

# OPEN CSV AS VARIALBE RIGHT HERE
with open('cat_list.txt') as jf:
    cat_list = json.load(jf)

class FindingApi:
    finding_service = [
        'findItemsAdvanced', 'findCompletedItems',
        'findItemsByKeywords', 'findItemsIneBayStores', 'findItemsByCategory',
        'findItemsByProduct'
        ]
    pageNumber = list(range(1, 63))

    # departments = ["3034","93427"]

    def get_ids(self):
        itemid_results_list = []
        for category_id in cat_list:
            for i in FindingApi.pageNumber:
                params = {
                    "OPERATION-NAME":FindingApi.finding_service[4],
                    "SECURITY-APPNAME":"scottbea-xlister-PRD-6796e0ff6-14862949",
                    "SERVICE-VERSION":"1.13.0",
                    "RESPONSE-DATA-FORMAT":"JSON",
                    "categoryId":category_id,
                    "paginationInput.entriesPerPage":"100",
                    "paginationInput.PageNumber":FindingApi.pageNumber[i]
                    }
                # extract item id here for piping into shopping_test.py

                response = requests.get("https://svcs.ebay.com/services/search/FindingService/v1", params=params)
                data = response.json()
                for item in data['findItemsByCategoryResponse'][0]['searchResult'[0]['item']:
                    itemid_results_list.append(item['itemId']) # above this line you will have to check whether the id exists in the pandas dataframe before you go on to create your list for the shopping
                    #api: check df --> if does not exist, append itemId to itemid_results_list --> with curated list, make a list of 20-itemId lists. 
        item_id_results = list(map(str, itemid_results_list))
        item_id_results = ','.join(item_id_results) # you will have to split this into 20 item lists strings to feed into ItemID param. Consider making a list of str lists.
        return item_id_results

class ShoppingApi:

    def get_item(self):

        params = {
            "callname":"GetMultipleItems",
            "appid":"scottbea-xlister-PRD-6796e0ff6-14862949",
            "version":"671",
            "responseencoding":"JSON",
            "ItemID":item_id_results, # you pass in a list? If not then maybe a comma-separated
            "IncludeSelector":"ItemSpecifics",
            }

        response = requests.get("https://open.api.ebay.com/shopping?", params=params)
        data = response.json()

        names = []
        values = []
        nvl = data['Item'][0]['ItemSpecifics']['NameValueList']

        for nvl_dict in nvl:
            names.append(nvl_dict['Name'])
            values.append(nvl_dict['Value'])

        nvl_dict = dict(zip(names, values))
        data.update(nvl_dict)
        df = pd.json_normalize(data)
        df.to_csv('big_data.csv')

# Limited to 5000 calls to shopping api per day, and getMultpileitems service maxes out at 20 items
# per call leaving you 100,000 items per day for you pandas dataframe initially. So you'll have
# to divide these up into the categories. This will leave you with about 6.25K results per cat. 
# More than enough data for your dataset. Consider 
